#include<iostream>
#include<vector>
#include<algorithm>
#include<fstream>
#include<string>
#include <sstream>
#include<cstring>
#include<ctime>
using namespace std;

class CPalindromo 
{
	string palindromo;
	bool impar;

public:
	class CPalindromoInvalido 
	{
	public:
		CPalindromoInvalido(const string palavra)
		{
			cerr << palavra << " nao e um palindromo"	 << endl;
		}
	};

	CPalindromo () {impar = false;}
	void setPalindromo(const string palavra);
	int size () {
		if (impar)
			return 2*palindromo.size()-1;
		return 2*palindromo.size();
	}
	const char& operator[] (size_t pos); 
	friend ostream& operator<< (ostream& os, CPalindromo& pal);

};

void CPalindromo::setPalindromo (const string palavra)
{
	string palavraInvertida;

	// inverte palavra
	string::const_reverse_iterator it;
	for(it = palavra.rbegin(); it < palavra.rend(); it++)
	{
		palavraInvertida += *it ;
	}

	if (palavraInvertida != palavra)
		throw CPalindromoInvalido (palavra);

	int halfsize = palavra.size()/2 + palavra.size()%2;
	impar = palavra.size()%2 == 1;
	palindromo = palavra.substr(0, halfsize);

	cout << palindromo << " " << impar << endl; // DEBUG ONLY
}

ostream& operator<< (ostream& os, CPalindromo& pal)
{
	if (pal.size() == 0)
		return os;

	os << pal.palindromo;

	string::reverse_iterator it = pal.palindromo.rbegin();
	if (!pal.impar)
		os << *it;
	
	for(it++; it < pal.palindromo.rend(); it++)
	{
		os << *it;
	}
	return os;
}

int lerPalindromos (vector<CPalindromo *>& vp, const char * filename)
{
	ifstream file(filename);
	if (!file)
	{
		cerr << "erro ao abrir" << endl;
		return -1;
	}
	string palavra;
//	while(getline (file, palavra))
      while (!file.eof())
	{
		file >> palavra;
		if (!file)
			break;
		CPalindromo * cp = new CPalindromo;
		try {
			cp ->setPalindromo(palavra);
			vp.push_back(cp);
		}
		catch (...)
		{
			delete cp;
		}	
	}
	return 0;
}

void apagaPalindromosPequenos (vector<CPalindromo *>& vp, int minSize)
{
	vector<CPalindromo *>::iterator it;
	for (it = vp.begin(); it < vp.end(); )
	{
		CPalindromo * p = *it;
		if (p->size() < minSize)
		{
			it = vp.erase(it);
			delete p;
		}
		else
			it++;
	}
}

main ()
{
	CPalindromo pal;
	cout << pal << "INICIO\n";
	try 
	{
		pal.setPalindromo("RADAR");

		pal.setPalindromo("OSSO");
		pal.setPalindromo("ola");
	}
	catch (CPalindromo::CPalindromoInvalido)
	{
	}
	cout << "================\n";
	vector<CPalindromo *> pp;
	lerPalindromos (pp, "palavras.txt");
	cout << "================\n";
	for (unsigned int i = 0; i < pp.size(); i++)
	{
		cout << *pp[i] << endl;
	}
	cout << "================\n";
	apagaPalindromosPequenos (pp,4);
	for (unsigned int i = 0; i < pp.size(); i++)
	{
		cout << *pp[i] << endl;
	}
}

